//************************************************************************
// Program Name	: Read a Float and print it on the Screen as HEX
// Programmer	: Petros Panayi	Stud. ID: 000000
// Date  Modif.	: 1 Sep 2017
//************************************************************************
// Comments: Read a Float and print it on the Screen as HEX
// Stack Frame:
//				|-----------------------|
//	  			|						|
//		sp'-->	|-----------------------|
//	  			|			&f			|
//				|-----------------------|<-- fp + 28
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|		x30 = lr'		|
//				|-----------------------|
//	  			|		x30 = lr'		|
//				|-----------------------|<-- fp + 8
//	  			|		X29 = fp'		|
//				|-----------------------|
//	  			|		X29 = fp'		|
//sp=sp'-32 -->	|-----------------------| <-- fp
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//************************************************************************

    .data
in_message_str: .string	"Please give a Float: "
scanf_str: .string	"%f"
out_message_str: .string	"You have given the value 0x%X\n"
//************************************************************************	
	.text
	.global	main
main:

	stp	X29, X30, [sp, -32]!	//	First (!) move the stack pointer 32 bytes down (sp-32)
								//  and then store double x29 and x30. 
								// (pre-index modes whih means apply the offset before accessing the memory)
	add	x29, sp, 0				//	Copy the value of stack pointer to Frame Pointer
	
	adr 	x0, in_message_str				// Should Do the same job as the above two lines
	bl	printf					// Call Function printf

	add	x1, x29, 28				// Set the location to store the input value (fp+28)
	adr x0, scanf_str
	bl	scanf

	ldr	x1, [x29, 28]			// Load it into an integer register
							
	adr 	x0, out_message_str
	bl	printf				    // Call Function printf
	
	ldp	x29, x30, [sp], 32		// Release the stack space
	ret							// Return to loading function
//************************************************************************
