//************************************************************************
// Program Name	: Count the time in Clicks
// Programmer	: Petros Panayi	Stud. ID: 000000
// Date  Modif.	: 1 Sep 2017
//************************************************************************
// Comments: Read a Double and print it on the Screen
// Stack Frame:
//				|-----------------------|
//	  			|						|
//		sp'-->	|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|		x30 = lr'		|
//				|-----------------------|
//	  			|		x30 = lr'		|
//				|-----------------------|<-- fp + 8
//	  			|		X29 = fp'		|
//				|-----------------------|
//	  			|		X29 = fp'		|
//sp=sp'-32 -->	|-----------------------| <-- fp
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//************************************************************************
/* clock example: frequency of primes */
//#include <stdio.h>      /* printf */
//#include <time.h>       /* clock_t, clock, CLOCKS_PER_SEC */
//#include <math.h>       /* sqrt */

//int frequency_of_primes (int n) {
//  int i,j;
//  int freq=n-1;
//  for (i=2; i<=n; ++i) for (j=sqrt(i);j>1;--j) if (i%j==0) {--freq; break;}
//  return freq;
//}

//int main ()
//{
//  clock_t t;
//  int f;
//  t = clock();
//  printf ("Calculating...\n");
//  f = frequency_of_primes (99999);
//  printf ("The number of primes lower than 100,000 is: %d\n",f);
//  t = clock() - t;
//  printf ("It took me %d clicks (%f seconds).\n",t,((float)t)/CLOCKS_PER_SEC);
// return 0;
//}
//************************************************************************
//./a.out
// The time passed in Clicks is: 7177280 nSec (nano Second == 10^-9 Seconds)
//-> 7.180u 0.000s 0:07.18 100.0%    0+0k 0+0io 0pf+0w
//************************************************************************
    .data
out_message_str: .string	"The time passed in Clicks is: %llu nSec (nano Second == 10^-9 Seconds)\n"
//************************************************************************	
	.text
	.global	main
main:

	stp	X29, X30, [sp, -32]!	
	add	x29, sp, 0	
	
	add     x0, x29, 32
    bl      clock
	mov     x19, x0					// Time at start
	mov 	x3, 0xFFFFFFFF
loop:								// Do some useless work
	adds x3, x3, -1
	b.ne	loop

	bl clock						// Get the time at stop
	sub x1, x0, x19
	adr 	x0, out_message_str
	bl		printf				    // Call Function printf
	ldp	x29, x30, [sp], 32			// Release the stack space
	ret								// Return to loading function
//************************************************************************
